       PROGRAM TESTMATMUL

       use constants
       use matrixia,ONLY:matsqr3,matmul3,matmul3a,matmul3b

C
C***  variables
C
       IMPLICIT NONE
       INTEGER N,dim,i,j
       INTEGER MCLOCK,TE,TA
       PARAMETER(dim=600)
       REAL TIMEIT
       COMPLEX*16,DIMENSION(dim,dim)::A1,A2
       COMPLEX*16,DIMENSION(3,dim):: B
       COMPLEX*16,DIMENSION(dim,3):: B1
c      COMPLEX*16,DIMENSION(dim):: C
       REAL*4 C
 
C
C
       do 05 i=1,dim
          do 04 j=1,dim
           A1(i,j)=(1.,1.)
           A2(i,j)=(1.,1.)
 04       continue
          B(1,i)=(6.3*i,i)
          B(2,i)=(2.*i,i*.5)
          B(3,i)=(3.47*i,i/3.)
 05    continue
          C=8.6
       
       TA=MCLOCK()
c      CALL matmul3a(A1,transpose(B),B*(C))
       CALL  matsqr3(A1,B,C)
       TE=MCLOCK()
       write(*,*)(TE-TA)*.01,'sec fuer matsqr3'
c      B1=transpose(B)
       TA=MCLOCK()
c      A2(:,:)= A2(:,:)+matmul3(transpose(B),B*C)
       A2(:,:)= A2(:,:)+matmul3(transpose(conjg(B)),B)*C
c      A2(:,:)=A2(:,:)*C
c      A1= A1-matmul3(transpose(conjg(B)),B*C)
       TE=MCLOCK()
       write(*,*)(TE-TA)*.01,'sec fuer matmul3'
       C=0.
       do 10 i=1,dim
       do 10 j=1,dim
       C=C+ABS(A1(i,j)-A2(i,j))
       if(ABS(A1(i,j)-A2(i,j)).gt.1.E-4)then
        write(*,*)'error',i,j
        write(*,*)A1(i,j),A2(i,j)
        pause
       endif
 10    continue
       write(*,*)'diff =',C
       END
